/**
 * www.jcoverage.com
 * Copyright (C)2003 jcoverage ltd.
 *
 * This file is part of jcoverage.
 *
 * jcoverage is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * jcoverage is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with jcoverage; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */
package com.jcoverage.reporting;

import java.io.*;

import com.jcoverage.reporting.Serializer;

/**
 *
 */
public class FileSerializer implements Serializer {
	
  File baseDirectory;

  public FileSerializer(File baseDirectory) {
    this.baseDirectory=baseDirectory;
  }

  public Writer getWriterForPath(String path) throws ReportingException {
    try {
      File f=new File(baseDirectory,path);
      f.getParentFile().mkdirs();
      
      String charset = getCharSet();
      if (charset == null || "".equals(charset)) return new OutputStreamWriter(new FileOutputStream(f));
      return new OutputStreamWriter(new FileOutputStream(f), charset);
    } catch(IOException ex) {
      throw new ReportingException("Failed to create file writer",ex);
    }
  }
  
  private String getCharSet() {
	  String charset = System.getProperty("djunit.html.charset");
	  if ("shift_jis".equalsIgnoreCase(charset)) return "Windows-31J";
	  return charset;
  }
}
